/// Defines a C style structure.
#[macro_export]
macro_rules! c_struct
{
   {
      $(#[$sattr: meta])*
      $cname: ident
      {
         $($(#[$attr: meta])* $name: ident: $type: ty);*;
      }
   } =>
   {
      $(#[$sattr])*
      #[repr(C)]
      pub struct $cname
      {
         $($(#[$attr])* pub $name: $type),+,
      }
   };
}
