#[macro_export]
macro_rules! c_library
{
   {
      $(statics:
        {
           $($(#[$satter: meta])* $sname: ident: $stype: ty);+;
        }
      )?

      $(functions:
        {
           $($(#[$fatter: meta])* $fname: ident($($farg: ident: $fargt: ty),*) -> $fret:ty);+;
        }
      )?

      $(varargs:
        {
           $($(#[$vatter: meta])* $vname: ident($($vargs: ident: $vargst: ty),+) -> $vret:ty);+;
        }
      )?
   } =>
   {
      extern "C"
      {
         $($($(#[$satter])* pub static $sname: $stype;)+)?

         $($($(#[$fatter])* pub fn $fname($($farg: $fargt),*) -> $fret;)+)?

         $($($(#[$vatter])* pub fn $vname($(vargs: $vargst),+ , ...) -> $vret;)+)?
      }
   };
}

#[macro_export]
macro_rules! external_library
{
   {
      $name: ident: $link: expr =>
      {
         $(statics:
           {
              $($(#[$satter: meta])* $sname: ident: $stype: ty);+;
           }
         )?

         $(functions:
           {
              $($(#[$fatter: meta])* $fname: ident($($farg: ident: $fargt: ty),*) -> $fret:ty);+;
           }
         )?

         $(varargs:
           {
              $($(#[$vatter: meta])* $vname: ident($($vargs: ident: $vargst: ty),+) -> $vret:ty);+;
           }
         )?
      }
   } =>
   {
      #[link(name=$link)]
      extern "C"
      {
         $($($(#[$satter])* pub static $sname: $stype;)+)?

         $($($(#[$fatter])* pub fn $fname($($farg: $fargt),*) -> $fret;)+)?

         $($($(#[$vatter])* pub fn $vname($(vargs: $vargst),+ , ...) -> $vret;)+)?
      }
   };
}
